]> git.ipfire.org Git - thirdparty/git.git/blob - git-am.sh
enable separate reflog for HEAD
[thirdparty/git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
4
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8 | --no-utf8] [--binary] [--3way]
6 [--interactive] [--whitespace=<option>] <mbox>...
7 or, when resuming [--skip | --resolved]'
8 . git-sh-setup
9 set_reflog_action am
10 require_work_tree
11
12 git var GIT_COMMITTER_IDENT >/dev/null || exit
13
14 stop_here () {
15 echo "$1" >"$dotest/next"
16 exit 1
17 }
18
19 stop_here_user_resolve () {
20 if [ -n "$resolvemsg" ]; then
21 echo "$resolvemsg"
22 stop_here $1
23 fi
24 cmdline=$(basename $0)
25 if test '' != "$interactive"
26 then
27 cmdline="$cmdline -i"
28 fi
29 if test '' != "$threeway"
30 then
31 cmdline="$cmdline -3"
32 fi
33 if test '.dotest' != "$dotest"
34 then
35 cmdline="$cmdline -d=$dotest"
36 fi
37 echo "When you have resolved this problem run \"$cmdline --resolved\"."
38 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
39
40 stop_here $1
41 }
42
43 go_next () {
44 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
45 "$dotest/patch" "$dotest/info"
46 echo "$next" >"$dotest/next"
47 this=$next
48 }
49
50 cannot_fallback () {
51 echo "$1"
52 echo "Cannot fall back to three-way merge."
53 exit 1
54 }
55
56 fall_back_3way () {
57 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
58
59 rm -fr "$dotest"/patch-merge-*
60 mkdir "$dotest/patch-merge-tmp-dir"
61
62 # First see if the patch records the index info that we can use.
63 git-apply -z --index-info "$dotest/patch" \
64 >"$dotest/patch-merge-index-info" &&
65 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
66 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
67 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68 git-write-tree >"$dotest/patch-merge-base+" ||
69 cannot_fallback "Patch does not record usable index information."
70
71 echo Using index info to reconstruct a base tree...
72 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
73 git-apply $binary --cached <"$dotest/patch"
74 then
75 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
77 else
78 cannot_fallback "Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
80 fi
81
82 test -f "$dotest/patch-merge-index" &&
83 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
84 orig_tree=$(cat "$dotest/patch-merge-base") &&
85 rm -fr "$dotest"/patch-merge-* || exit 1
86
87 echo Falling back to patching base and 3-way merge...
88
89 # This is not so wrong. Depending on which base we picked,
90 # orig_tree may be wildly different from ours, but his_tree
91 # has the same set of wildly different changes in parts the
92 # patch did not touch, so recursive ends up canceling them,
93 # saying that we reverted all those changes.
94
95 eval GITHEAD_$his_tree='"$SUBJECT"'
96 export GITHEAD_$his_tree
97 git-merge-recursive $orig_tree -- HEAD $his_tree || {
98 if test -d "$GIT_DIR/rr-cache"
99 then
100 git-rerere
101 fi
102 echo Failed to merge in the changes.
103 exit 1
104 }
105 unset GITHEAD_$his_tree
106 }
107
108 prec=4
109 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary= ws= resolvemsg=
110
111 while case "$#" in 0) break;; esac
112 do
113 case "$1" in
114 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
115 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
116 -d|--d|--do|--dot|--dote|--dotes|--dotest)
117 case "$#" in 1) usage ;; esac; shift
118 dotest="$1"; shift;;
119
120 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
121 --interacti|--interactiv|--interactive)
122 interactive=t; shift ;;
123
124 -b|--b|--bi|--bin|--bina|--binar|--binary)
125 binary=t; shift ;;
126
127 -3|--3|--3w|--3wa|--3way)
128 threeway=t; shift ;;
129 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
130 sign=t; shift ;;
131 -u|--u|--ut|--utf|--utf8)
132 utf8=t; shift ;; # this is now default
133 --no-u|--no-ut|--no-utf|--no-utf8)
134 utf8=; shift ;;
135 -k|--k|--ke|--kee|--keep)
136 keep=t; shift ;;
137
138 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
139 resolved=t; shift ;;
140
141 --sk|--ski|--skip)
142 skip=t; shift ;;
143
144 --whitespace=*)
145 ws=$1; shift ;;
146
147 --resolvemsg=*)
148 resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;
149
150 --)
151 shift; break ;;
152 -*)
153 usage ;;
154 *)
155 break ;;
156 esac
157 done
158
159 # If the dotest directory exists, but we have finished applying all the
160 # patches in them, clear it out.
161 if test -d "$dotest" &&
162 last=$(cat "$dotest/last") &&
163 next=$(cat "$dotest/next") &&
164 test $# != 0 &&
165 test "$next" -gt "$last"
166 then
167 rm -fr "$dotest"
168 fi
169
170 if test -d "$dotest"
171 then
172 case "$#,$skip$resolved" in
173 0,*t*)
174 # Explicit resume command and we do not have file, so
175 # we are happy.
176 : ;;
177 0,)
178 # No file input but without resume parameters; catch
179 # user error to feed us a patch from standard input
180 # when there is already .dotest. This is somewhat
181 # unreliable -- stdin could be /dev/null for example
182 # and the caller did not intend to feed us a patch but
183 # wanted to continue unattended.
184 tty -s
185 ;;
186 *)
187 false
188 ;;
189 esac ||
190 die "previous dotest directory $dotest still exists but mbox given."
191 resume=yes
192 else
193 # Make sure we are not given --skip nor --resolved
194 test ",$skip,$resolved," = ,,, ||
195 die "Resolve operation not in progress, we are not resuming."
196
197 # Start afresh.
198 mkdir -p "$dotest" || exit
199
200 git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
201 rm -fr "$dotest"
202 exit 1
203 }
204
205 # -b, -s, -u, -k and --whitespace flags are kept for the
206 # resuming session after a patch failure.
207 # -3 and -i can and must be given when resuming.
208 echo "$binary" >"$dotest/binary"
209 echo " $ws" >"$dotest/whitespace"
210 echo "$sign" >"$dotest/sign"
211 echo "$utf8" >"$dotest/utf8"
212 echo "$keep" >"$dotest/keep"
213 echo 1 >"$dotest/next"
214 fi
215
216 case "$resolved" in
217 '')
218 files=$(git-diff-index --cached --name-only HEAD) || exit
219 if [ "$files" ]; then
220 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
221 exit 1
222 fi
223 esac
224
225 if test "$(cat "$dotest/binary")" = t
226 then
227 binary=--allow-binary-replacement
228 fi
229 if test "$(cat "$dotest/utf8")" = t
230 then
231 utf8=-u
232 else
233 utf8=-n
234 fi
235 if test "$(cat "$dotest/keep")" = t
236 then
237 keep=-k
238 fi
239 ws=`cat "$dotest/whitespace"`
240 if test "$(cat "$dotest/sign")" = t
241 then
242 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
243 s/>.*/>/
244 s/^/Signed-off-by: /'
245 `
246 else
247 SIGNOFF=
248 fi
249
250 last=`cat "$dotest/last"`
251 this=`cat "$dotest/next"`
252 if test "$skip" = t
253 then
254 if test -d "$GIT_DIR/rr-cache"
255 then
256 git-rerere clear
257 fi
258 this=`expr "$this" + 1`
259 resume=
260 fi
261
262 if test "$this" -gt "$last"
263 then
264 echo Nothing to do.
265 rm -fr "$dotest"
266 exit
267 fi
268
269 while test "$this" -le "$last"
270 do
271 msgnum=`printf "%0${prec}d" $this`
272 next=`expr "$this" + 1`
273 test -f "$dotest/$msgnum" || {
274 resume=
275 go_next
276 continue
277 }
278
279 # If we are not resuming, parse and extract the patch information
280 # into separate files:
281 # - info records the authorship and title
282 # - msg is the rest of commit log message
283 # - patch is the patch body.
284 #
285 # When we are resuming, these files are either already prepared
286 # by the user, or the user can tell us to do so by --resolved flag.
287 case "$resume" in
288 '')
289 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
290 <"$dotest/$msgnum" >"$dotest/info" ||
291 stop_here $this
292 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
293 ;;
294 esac
295
296 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
297 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
298 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
299
300 if test -z "$GIT_AUTHOR_EMAIL"
301 then
302 echo "Patch does not have a valid e-mail address."
303 stop_here $this
304 fi
305
306 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
307
308 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
309 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
310
311 case "$resume" in
312 '')
313 if test '' != "$SIGNOFF"
314 then
315 LAST_SIGNED_OFF_BY=`
316 sed -ne '/^Signed-off-by: /p' \
317 "$dotest/msg-clean" |
318 tail -n 1
319 `
320 ADD_SIGNOFF=`
321 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
322 test '' = "$LAST_SIGNED_OFF_BY" && echo
323 echo "$SIGNOFF"
324 }`
325 else
326 ADD_SIGNOFF=
327 fi
328 {
329 echo "$SUBJECT"
330 if test -s "$dotest/msg-clean"
331 then
332 echo
333 cat "$dotest/msg-clean"
334 fi
335 if test '' != "$ADD_SIGNOFF"
336 then
337 echo "$ADD_SIGNOFF"
338 fi
339 } >"$dotest/final-commit"
340 ;;
341 *)
342 case "$resolved$interactive" in
343 tt)
344 # This is used only for interactive view option.
345 git-diff-index -p --cached HEAD >"$dotest/patch"
346 ;;
347 esac
348 esac
349
350 resume=
351 if test "$interactive" = t
352 then
353 test -t 0 ||
354 die "cannot be interactive without stdin connected to a terminal."
355 action=again
356 while test "$action" = again
357 do
358 echo "Commit Body is:"
359 echo "--------------------------"
360 cat "$dotest/final-commit"
361 echo "--------------------------"
362 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
363 read reply
364 case "$reply" in
365 [yY]*) action=yes ;;
366 [aA]*) action=yes interactive= ;;
367 [nN]*) action=skip ;;
368 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
369 action=again ;;
370 [vV]*) action=again
371 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
372 *) action=again ;;
373 esac
374 done
375 else
376 action=yes
377 fi
378
379 if test $action = skip
380 then
381 go_next
382 continue
383 fi
384
385 if test -x "$GIT_DIR"/hooks/applypatch-msg
386 then
387 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
388 stop_here $this
389 fi
390
391 echo
392 echo "Applying '$SUBJECT'"
393 echo
394
395 case "$resolved" in
396 '')
397 git-apply $binary --index $ws "$dotest/patch"
398 apply_status=$?
399 ;;
400 t)
401 # Resolved means the user did all the hard work, and
402 # we do not have to do any patch application. Just
403 # trust what the user has in the index file and the
404 # working tree.
405 resolved=
406 changed="$(git-diff-index --cached --name-only HEAD)"
407 if test '' = "$changed"
408 then
409 echo "No changes - did you forget to use 'git add'?"
410 stop_here_user_resolve $this
411 fi
412 unmerged=$(git-ls-files -u)
413 if test -n "$unmerged"
414 then
415 echo "You still have unmerged paths in your index"
416 echo "did you forget to use 'git add'?"
417 stop_here_user_resolve $this
418 fi
419 apply_status=0
420 if test -d "$GIT_DIR/rr-cache"
421 then
422 git rerere
423 fi
424 ;;
425 esac
426
427 if test $apply_status = 1 && test "$threeway" = t
428 then
429 if (fall_back_3way)
430 then
431 # Applying the patch to an earlier tree and merging the
432 # result may have produced the same tree as ours.
433 changed="$(git-diff-index --cached --name-only HEAD)"
434 if test '' = "$changed"
435 then
436 echo No changes -- Patch already applied.
437 go_next
438 continue
439 fi
440 # clear apply_status -- we have successfully merged.
441 apply_status=0
442 fi
443 fi
444 if test $apply_status != 0
445 then
446 echo Patch failed at $msgnum.
447 stop_here_user_resolve $this
448 fi
449
450 if test -x "$GIT_DIR"/hooks/pre-applypatch
451 then
452 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
453 fi
454
455 tree=$(git-write-tree) &&
456 echo Wrote tree $tree &&
457 parent=$(git-rev-parse --verify HEAD) &&
458 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
459 echo Committed: $commit &&
460 git-update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
461 stop_here $this
462
463 if test -x "$GIT_DIR"/hooks/post-applypatch
464 then
465 "$GIT_DIR"/hooks/post-applypatch
466 fi
467
468 go_next
469 done
470
471 rm -fr "$dotest"